﻿@model IEnumerable<IntegrationItemModel>
@using System.Security.Claims
@using LAP.DomainModels
@using LAP.DomainModels.Models
@{
    ViewData["Title"] = "Connected Apps";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
    var prevNext = ViewBag.nextPrev != null ? (PrevNextMenuModel)ViewBag.nextPrev : new PrevNextMenuModel();
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="card-header flex-wrap border-0 p-0">
                <div class="card-title mb-0">
                    <div class="d-flex justify-content-between">
                        <div>
                            <h3 class="card-label text-primary">
                                Settings
                            </h3>
                        </div>
                        <div>
                            <button class="btn btn-secondary font-weight-bold px-6 py-2" id="save-exit-setting">Save & Exit</button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-2 border-right">
                    <partial name="_SettingsNavBar" />
                </div>
                <div class="col-md-10">
                    <div id="wizard-content">
                        <div class="wizard-content-height">
                            <div class="tab-content mt-3" id="myTabContent">
                                <div class="tab-pane fade show active" id="kt_tab_pane_1" role="tabpanel" aria-labelledby="kt_tab_pane_2">
                                    <div class="row">
                                        @foreach (var item in Model.Select((value, i) => new { i, value }))
                                        {
                                            <div class="col-md-6">
                                                <div class="partners-callout border border-2 border-primary">
                                                    <div class="d-flex">
                                                        <div class="symbol symbol-50 symbol-lg-120 border border-1 p-2 order-0 mr-5">
                                                            <img src="~/images/integration-logo/@item.value.LogoFileName" />
                                                        </div>
                                                        <div class="flex-grow-1">
                                                            <div class="d-flex align-items-center justify-content-between flex-wrap mt-2">
                                                                <div class="mr-3 order-0">
                                                                    <span class="d-flex align-items-center text-dark font-size-h5 font-weight-bold mr-3">
                                                                        @Html.Raw(item.value.Title)
                                                                    </span>
                                                                </div>
                                                                <div class="card-toolbar integration">
                                                                    <span class="switch switch-outline switch-icon switch-custom switch-xs justify-content-center" data-toggle="tooltip" data-original-title="Configure">
                                                                        <label>
                                                                            <input type="checkbox" id="@item.value.PartnerName.Replace(" ","")-configure" class="configure" @(item.value.Connected ? "checked":null)>
                                                                            <span></span>
                                                                        </label>
                                                                    </span>
                                                                </div>
                                                            </div>
                                                            <div class="d-flex align-items-center flex-wrap justify-content-between">
                                                                <div class="flex-grow-1 font-weight-bold text-dark-50 py-2 py-lg-2">
                                                                    @item.value.Description
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        }
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <partial name="_SettingWizardFooter" />
                </div>
            </div>
        </div>
    </div>
</div>
<style>
    .navi.navi-active .navi-item .navi-link.active {
        background-color: #E1F0FF;
    }
</style>
<div class="modal" id="IntegrationModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
</div>
@section scripts{
    <script>
        setTimeout(function () {
            $("#btn-submit,#btn-next").addClass("d-none");
            $("#btn-complete").removeClass("d-none").removeAttr("data-original-title");
            if (window.location.search.includes("flag"))
                $("#btn-complete").addClass("d-none");
        }, 0);
        $("#btn-complete,#save-exit-setting").click(function (e) {
            e.preventDefault();
            var btn = KTUtil.getById(e.target.id);
            var spinnerClass = e.target.id == "btn-complete" ? "white" : "dark";
            KTUtil.btnWait(btn, `spinner spinner-right spinner-${spinnerClass} pr-15`, "Please wait");
            window.location.href = "@area/client-list";
        });
        $(".configure").change(function () {
            var partner = $(this).attr("id").replace("-configure", "");
            var partnerName = partner.replace(/([A-Z])/g, ' $1').trim();
            var url = `adviser/integration/auth${partner}`;
            toastr.options = toastrOptions;
            var el = $(`#${partner}-configure`);
            el.prop("disabled", true);
            if (el.is(":checked")) {
                loadPartialView(`adviser/settings/integrationauth`, "IntegrationModal", null, function () {
                    $("#integration-partner").text(partnerName);
                    $("#integration-partner-name").val(partner);
                });
                $("#IntegrationModal").html("");
                $("#IntegrationModal").modal({ backdrop: 'static', keyboard: false });
            }
            else {
                $.post(url, { active: false }, function (response) {
                    toastr.clear();
                    toastr.warning(response.message);
                    el.prop("disabled", false);
                    $(`#IntegrationModal`).modal('hide');
                });
            }
        })
        $(document).on('click', "#btn-auth-integration", function () {
            $(".alert").remove();
            if ($("#auth-frm").valid()) {
                var btn = KTUtil.getById("btn-auth-integration");
                KTUtil.btnWait(btn, "spinner spinner-right spinner-white pr-15", "Please wait");
                var partner = $("#integration-partner-name").val();
                var url = `adviser/integration/auth${partner}`;
                $.post(url, $("#auth-frm").serialize(), function (response) {
                    if (response.success) {
                        toastr.clear();
                        toastr.success(response.message);
                        $(`#IntegrationModal`).modal('hide');
                    }
                    else {
                        var errorClass = response.message.includes("2FA") ? "warning" : "danger";
                        _showFormMessage("auth-frm", errorClass, response.message, "fas fa-exclamation-triangle")
                    }
                    $(`#${partner}-configure`).prop("checked", response.success);
                    $(`#${partner}-configure`).prop("disabled", false);
                    KTUtil.btnRelease(btn);
                });
            }
        });
        $(document).on('click', "#IntegrationModal .close", function () {
            var partner = $("#integration-partner-name").val();
            var el = $(`#${partner}-configure`);
            el.prop("checked", false);
            el.prop("disabled", false);
        })
    </script>
}
<style>
    .partners-callout {
        padding: 20px;
        margin: 10px 0;
        border-left-width: 7px;
        border-radius: 10px;
    }
</style>